/**
 * 控件渲染器
 */
define("./JGDemoWidget", function (require, exports, module) {
	var sandbox;
	var widgetContext;
	exports.initModule = function (sb) {
		
		//模块初始化
		sandbox = sb;
		widgetContext = sandbox.getService("vjs.framework.extension.widget.manager.widgetContext");
		
		initUI();
		
	};
	
	/**
	 * UI定义（此方法只运行一次）
	 * 
	 * 在这里可以基于第三方UI进行定制
	 */
	var initUI = function(){
		
		
		
		isc.ClassFactory.defineClass("JGDemoWidget", "JGBaseWidget");
		isc.JGDemoWidget.addProperties({
			
			WidgetStyle : "JGDemoWidget",
			_button: null,
			LabelText : '按钮',
			listener:['click']
			
		});

		isc.JGDemoWidget.addMethods({
			//自定义控件可覆盖父类的这个方法，扩展本控件的初始实例化逻辑，相当于控件的构造函数
			_initWidget : function () {
				
		        this._button = isc.Button.create({
		            id: this.id,
		            title: this.LabelText,
		            width: this.Width,
		            height: this.Height,
					//防止事件执行过久而导致用户继续触发,功能与_referEvent相同
					click : this._referEvent(this,'click'),//按钮事件触发同样触发父亲的事件
					baseStyle :this.WidgetStyle
		        });
				
				// 必须添加到本控件的内部SC画布中，否则无法支持SC的父子控件层次关系
				this.addChild(this._button);
				
			}
		});
	}
	
	
	/**
	 * 控件UI初始化，产生UI实例
	 */
	var init = function (properties) {
		
		var widgetId = properties.widgetId;
		var widget = isc.JGDemoWidget.create(properties);
		widgetContext.put(widgetId, "widgetObj", widget);
	};
	
	/**
	 * 在这里实现操作UI的其他方法
	 */
	 
	exports.init = init;
});
